Subject: bug#20628: 25.0.50; Incorrect line height for some fonts

From: Clément Pit--Claudel <[email-masked]>
Date: Sun, 24 May 2015 04:20:50 -0400

On 05/23/2015 03:24 AM, Eli Zaretskii wrote:
>> Date: Fri, 22 May 2015 19:55:24 -0400 From: Clément Pit--Claudel 
>> <[email-masked]> CC: Eli Zaretskii <[email-masked]>,
>> [email-masked]
>> 
>>> BTW, I think that using something like
>>> 
>>> (set-fontset-font fontset 'unicode (font-spec :name "Symbola")
>>> nil 'append) or (set-fontset-font "fontset-default" '(#x1d400 .
>>> #x1d7ff) "Symbola")
>>> 
>>> just sucks: we don't want to say "use Symbola", but we instead
>>> want to say something like "avoid Latin Modern Math" or "ignore
>>> Latin Modern Math's ascent/descent information".
>> 
>> I don't think so; this forces us to maintain a list of misbehaving 
>> fonts. If we just say "Avoid Latin Modern Math" and the next 
>> selected font is also broken, then the problem remains (Asana
>> Math, for example, is broken too, albeit a bit less). Ideally, we
>> would also want to be able to use Latin Modern Math: ignoring the
>> height issue, it's a nice font for maths symbols.
> 
> But the proposed patch, to which you agreed, did precisely that: it 
> singled out a particular font where the ascent/descent information
> was to be ignored (and suggested to extend the list if needed).

I meant to disagree with the part regarding ignoring a font entirely. Maintaining a list of broken fonts in a way that still allows us to use them (for example by overriding line height information) is not the most robust solution (ideally, we'd like to support these fonts just like virtually every other program out there), but it's still an improvement over the current situation. 

On the other hand, adding Latin Modern Math to a list of ignored fonts means that:
* Emacs suddenly seems to not support one of the fonts that users can use elsewhere without problems (e.g. in LibreOffice). 
* If Latin Modern Math is the only font that covers a particular character, we've changed "incorrect line height" into "square boxes in place of symbols", which is hardly an improvement over the current behaviour.
* If users install a fixed version of Latin Modern Math, is still won't be used unless they also remove Latin Modern from the ignore list.

> How's that different from what Stefan proposes?  And what's wrong
> with maintaining a list of fonts that are known to misbehave?  There
> a lot of broken fonts out there, and so far we relied on users
> configuring the fonts on their machines to avoid negative effects,
> something that's not always possible.
> 
>